import 'dart:io';

import "package:http/http.dart" as Http;
import 'package:path_provider/path_provider.dart';
import 'package:speedq_net/TokenResponse.dart';

import 'package:speedq_net/src/util/json.dart';

class HttpClient {
    static final String _root = "https://skipdq.herokuapp.com";
    static final _Client _client = new _Client();

    static void authorise(String token) {
        _client.token = token;
    }

    static void refresh(String id, String refresh, Function callback) {
        post("/refresh", "{\"id\": \"$id\", \"refresh\": \"$refresh\"}", (Http.Response response) {
            // get token response
            TokenResponse tokenResponse = TokenResponse.fromJson(response.body);
            authorise(tokenResponse.access);
            // write to file
            // get documents dir
            getApplicationDocumentsDirectory().then((dir) {
                // write to file
                File("${dir.path}/token.json").writeAsString(response.body);
            });
            callback();
        });
    }

    static void get(String endPoint, Type type, Function callback) {
        // callback cuz dart is gay
        _client.read(Uri.parse("${_root}endPoint")).then((json) => callback(create(json, type)));
    }

    static void post(String endPoint, String json, [Function? callback]) {
        if(callback == null) {
            _client.post(Uri.parse("${_root}endPoint"), body: json);
        } else {
            _client.post(Uri.parse("${_root}endPoint"), body: json).then((response) => callback(response));
        }
    }

    static String getRoot() {
        return _root;
    }
}

class _Client extends Http.BaseClient {
    late String token;
    final Http.Client _inner = new Http.Client();

    @override
    Future<Http.StreamedResponse> send(Http.BaseRequest request) {
        // add auth token to all requests
        request.headers["Authorization"] = "Bearer $token";
        request.headers["content-type"] = "application/json";
        return _inner.send(request);
    }

}